VERSION 5.00
Begin VB.UserControl SystemTray 
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   InvisibleAtRuntime=   -1  'True
   Picture         =   "SystemTray.ctx":0000
   ScaleHeight     =   480
   ScaleWidth      =   480
   ToolboxBitmap   =   "SystemTray.ctx":0C42
End
Attribute VB_Name = "SystemTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ISubclass

Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Const BDR_RAISED = &H5
Private Const BF_LEFT = &H1
Private Const BF_RIGHT = &H4
Private Const BF_TOP = &H2
Private Const BF_BOTTOM = &H8
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private nid As NOTIFYICONDATA

Event LeftClick()
Attribute LeftClick.VB_MemberFlags = "200"
Event DblClick()
Event RightClick()

'Default Property Values:
Const m_def_Caption = ""
'Property Variables:
Dim m_Caption As String
Dim m_Icon As IPictureDisp
Dim m_Visible As Boolean

' Overloading the interface...
Private Property Let ISubclass_MsgResponse(ByVal RHS As SSubTimer.EMsgResponse)
'
End Property

Private Property Get ISubclass_MsgResponse() As SSubTimer.EMsgResponse
    ISubclass_MsgResponse = emrPreprocess
End Property

Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case lParam
    Case WM_LBUTTONDBLCLK:  RaiseEvent DblClick
    Case WM_RBUTTONUP:      RaiseEvent RightClick
    Case WM_LBUTTONUP:      RaiseEvent LeftClick
    End Select
End Function
'-----------------------

Private Sub UserControl_Paint()
    Dim rc As RECT
    
    GetClientRect UserControl.hwnd, rc
    DrawEdge UserControl.hdc, rc, BDR_RAISED, BF_RECT
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    Set m_Icon = PropBag.ReadProperty("Icon", Nothing)
    m_Visible = PropBag.ReadProperty("Visible", True)
    
    If UserControl.Ambient.UserMode Then
        With nid
            .cbSize = Len(nid)
            If Not m_Icon Is Nothing Then .hIcon = m_Icon
            .hwnd = UserControl.hwnd
            .szTip = m_Caption & vbNullChar
            .uCallbackMessage = WM_MOUSEMOVE
            .uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
            .uID = 999
        End With
        
        If m_Visible Then Shell_NotifyIcon NIM_ADD, nid
        AttachMessage Me, UserControl.hwnd, WM_MOUSEMOVE
    End If
End Sub

Private Sub UserControl_Resize()
    UserControl.Size 32 * Screen.TwipsPerPixelX, 32 * Screen.TwipsPerPixelY
End Sub

Private Sub UserControl_Terminate()
    Shell_NotifyIcon NIM_DELETE, nid
    DetachMessage Me, UserControl.hwnd, WM_MOUSEMOVE
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Tooltip displayed over the system tray icon."
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Caption.VB_MemberFlags = "200"
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    nid.szTip = m_Caption & vbNullChar
    Shell_NotifyIcon NIM_MODIFY, nid
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=9,0,0,0
Public Property Get Icon() As IPictureDisp
Attribute Icon.VB_Description = "Icon displayed in the system tray."
Attribute Icon.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Set Icon = m_Icon
End Property

Public Property Set Icon(ByVal New_Icon As IPictureDisp)
    Set m_Icon = New_Icon
    PropertyChanged "Icon"
    If Not m_Icon Is Nothing Then
        nid.hIcon = m_Icon
        Shell_NotifyIcon NIM_MODIFY, nid
    End If
End Property

Public Property Get Visible() As Boolean
Attribute Visible.VB_Description = "Returns/sets if the icon is displayed in the tray."
Attribute Visible.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Visible = m_Visible
End Property

Public Property Let Visible(New_Value As Boolean)
    If m_Visible <> New_Value Then
        If Ambient.UserMode Then
            If New_Value Then
                ' Show icon
                Shell_NotifyIcon NIM_ADD, nid
            Else
                ' Hide
                Shell_NotifyIcon NIM_DELETE, nid
            End If
        End If
    End If
    
    m_Visible = New_Value
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Caption = UserControl.Ambient.DisplayName
    Set m_Icon = UserControl.Extender.Parent.Icon
    m_Visible = True
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("Icon", m_Icon, Nothing)
    Call PropBag.WriteProperty("Visible", m_Visible, True)
End Sub

Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_Description = "Display the about box."
Attribute ShowAboutBox.VB_UserMemId = -552
    frmAbout.Show 1
End Sub
